//+------------------------------------------------------------------+
//|                                           OOP_CDeleteOrder_1.mqh |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"

/*
      OOP_sDeleteOrders_1  .
*/
//---      CTrade   
#include <Trade/Trade.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class COrderDelete
  {
private:
   //---   
   bool              m_AllSymbol;
   bool              m_BuyStop;
   bool              m_SellStop;
   bool              m_BuyLimit;
   bool              m_SellLimit;
   bool              m_BuyStopLimit;
   bool              m_SellStopLimit;
   //---   CTrade
   CTrade            m_Trade; 
public:
   //+------------------------------------------------------------------+
   //|                                     |
   //+------------------------------------------------------------------+
   void Init(bool aAllSymbol,bool aBuyStop,bool aSellStop,bool aBuyLimit,bool aSellLimit,bool aBuyStopLimit,bool aSellStopLimit)
     {
      //  
      m_AllSymbol=aAllSymbol;
      m_BuyStop=aBuyStop;
      m_SellStop=aSellStop;
      m_BuyLimit=aBuyLimit;
      m_SellLimit=aSellLimit;
      m_BuyStopLimit=aBuyStopLimit;
      m_SellStopLimit=aSellStopLimit;
     }
   //+------------------------------------------------------------------+
   //|                                 |
   //+------------------------------------------------------------------+
   bool Delete()
     {
      bool m_Ret=true; //      
      for(int i=0;i<OrdersTotal();i++)
        { //     
         ulong m_Ticket=OrderGetTicket(i); //      
         if(m_Ticket>0)
           { //  
            long m_Type=OrderGetInteger(ORDER_TYPE);
            //   
            if(m_Type==ORDER_TYPE_BUY_STOP && !m_BuyStop)continue;
            if(m_Type==ORDER_TYPE_SELL_STOP && !m_SellStop)continue;
            if(m_Type==ORDER_TYPE_BUY_LIMIT && !m_BuyLimit)continue;
            if(m_Type==ORDER_TYPE_SELL_LIMIT && !m_SellLimit)continue;
            if(m_Type==ORDER_TYPE_BUY_STOP_LIMIT && !m_BuyStopLimit)continue;
            if(m_Type==ORDER_TYPE_SELL_STOP_LIMIT && !m_SellStopLimit)continue;
            if(!m_AllSymbol && Symbol()!=OrderGetString(ORDER_SYMBOL))continue; //  
            if(!m_Trade.OrderDelete(m_Ticket))
              { // 
               m_Ret=false; //  
              }
           }
         else
           {
            m_Ret=false; //    ,  ,     
            Print("  ");
           }
        }
      return(m_Ret); //    
     }
  };
//+------------------------------------------------------------------+
